package io.accumulatenetwork.sdk.generated.errors;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("CallSite")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class CallSite implements Marshallable {
	private String funcName;
	private String file;
	private int line;

    //
	public String getFuncName() {
	    return funcName;
	}
	public void setFuncName(final String value) {
	    this.funcName = value;
	}

	public CallSite funcName(final String value) {
	    setFuncName(value);
	    return this;
	}
	public String getFile() {
	    return file;
	}
	public void setFile(final String value) {
	    this.file = value;
	}

	public CallSite file(final String value) {
	    setFile(value);
	    return this;
	}
	public int getLine() {
	    return line;
	}
	public void setLine(final int value) {
	    this.line = value;
	}

	public CallSite line(final int value) {
	    setLine(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.funcName == null || this.funcName.length() == 0)) {
            marshaller.writeString(1, this.funcName);
        }
        if (!(this.file == null || this.file.length() == 0)) {
            marshaller.writeString(2, this.file);
        }
        if (!(this.line == 0)) {
            marshaller.writeInt(3, this.line);
        }
        return marshaller.array();
    }
}
